Summary: stasher object repository server
Name: stasher
Version: 0.11.1
Release: 1%{?dist}%{?extrarelease}
License: GPL
Group: Applications/System
Source0: %{name}-%{version}.tar.bz2
Requires(post): /sbin/ldconfig systemd-units
Requires(preun): systemd-units
Requires(postun): /sbin/ldconfig systemd-units

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: libcxxbase-devel
BuildRequires: perl-devel perl-macros
BuildRequires: courier-unicode-devel
BuildRequires: systemd-rpm-macros

%description
A server process that replicates "objects" (or, rather, files) between
multiple servers, and keeps them in sync.

%package devel
Summary: Stasher object repository server development files
Requires: libcxxbase-devel %{name} = 0:%{version}-%{release}
Group: Development/Libraries

%description devel
This package installs development files for building applications that use
the object repository server.

%package perl
Summary: Perl bindings for the Stasher object repository server API
Group: Development/Libraries
Requires:  %{name} = 0:%{version}-%{release}

%description perl
This package installs a basic Perl module for accessing objects in the
Stasher object repository from Perl.

%prep
%setup -q

%build
%configure
%{__make} perl-configure PERL_CONFIGURE_FLAGS=INSTALLDIRS=vendor
%{__make} %{_smp_mflags}
%{__make} perl-build

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT
cd perl/Stasher
%{__make} install DESTDIR=$RPM_BUILD_ROOT
cd ../..
/usr/bin/find $RPM_BUILD_ROOT -type f -name .packlist -exec %{__rm} -f {} ';'
/usr/bin/find $RPM_BUILD_ROOT -type f -name perllocal.pod -exec %{__rm} -f {} ';'
/usr/bin/find $RPM_BUILD_ROOT -type f -name '*.bs' -a -size 0 -exec %{__rm} -f {} ';'

%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/stasher
%{__mkdir_p} $RPM_BUILD_ROOT%{_unitdir}
%{__install} -m 0555 sysinit.rc $RPM_BUILD_ROOT%{_datadir}/stasher/sysinit.rc
%{__install} -m 0555 stasher.sysinit $RPM_BUILD_ROOT%{_datadir}/stasher/sysinit
%{__install} -m 0444 packaging/fedora/stasher.service $RPM_BUILD_ROOT%{_unitdir}

touch $RPM_BUILD_ROOT%{_localstatedir}/stasher/stasher.logs

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/cron.hourly
%{__ln_s}  `realpath --relative-to %{_sysconfdir}/cron.hourly -m %{_datadir}/stasher/maillogs.sh` $RPM_BUILD_ROOT%{_sysconfdir}/cron.hourly/stasher-maillogs

rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
%post
/sbin/ldconfig
/bin/systemctl daemon-reload || :

%preun
if test "$1" = "0"
then
	/bin/systemctl stop stasher.service
	/bin/systemctl disable stasher.service
fi

%postun
/sbin/ldconfig
/bin/systemctl daemon-reload || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_libdir}/*.so.*
%dir %{_localstatedir}/stasher
%{_localstatedir}/stasher/apps
%{_localstatedir}/stasher/clusters
%{_localstatedir}/stasher/newnodes
%{_localstatedir}/stasher/nodes
%verify(user group mode) %config(missingok) %ghost %attr(644, root, root) %{_localstatedir}/stasher/stasher.logs
%{_bindir}/*
%{_unitdir}/*
%{_libexecdir}/stasher
%{_datadir}/stasher
%{_mandir}/man1/*
%config(noreplace) %{_sysconfdir}/stasherlogconfig
%{_sysconfdir}/cron.hourly/*

%files devel
%defattr(-,root,root,-)
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/stasher

%files perl
%defattr(-,root,root,-)
%{_mandir}/man3/*3pm.*
%{perl_vendorarch}/*.pm
%dir %{perl_vendorarch}/auto/Stasher
%{perl_vendorarch}/auto/Stasher/Stasher*

%changelog
* Tue Jan 10 2012 Sam Varshavchik <mrsam@octopus.email-scan.com> -
- Initial build.
